import { Renderer2, EventEmitter, ElementRef, NgZone } from '@angular/core';
import { ControlValueAccessor, Validator, AbstractControl, ValidationErrors } from '@angular/forms';
import { DomSanitizer } from '@angular/platform-browser';
import { MdEditorOption } from './md-editor.types';
export declare class MarkdownEditorComponent implements ControlValueAccessor, Validator {
    private platform;
    required: boolean;
    maxlength: number;
    private _ngZone;
    private _renderer2;
    private _domSanitizer;
    aceEditorContainer: ElementRef;
    previewContainer: ElementRef;
    hideToolbar: boolean;
    height: string;
    preRender: Function;
    postRender: Function;
    upload: Function;
    mode: string;
    private _mode;
    options: MdEditorOption;
    private _options;
    onEditorLoaded: EventEmitter<any>;
    onPreviewDomChanged: EventEmitter<HTMLElement>;
    hideIcons: any;
    showPreviewPanel: boolean;
    isFullScreen: boolean;
    dragover: boolean;
    isUploading: boolean;
    readonly markdownValue: string;
    private _markdownValue;
    previewHtml: any;
    private _aceEditorIns;
    private _aceEditorResizeTimer;
    private _convertMarkdownToHtmlTimer;
    private _markedJsOpt;
    private _isValueSettedByprogrammatically;
    private readonly _hasUploadFunction;
    private readonly _isInBrowser;
    private _onChange;
    private _onTouched;
    constructor(platform: Object, required: boolean, maxlength: number, _ngZone: NgZone, _renderer2: Renderer2, _domSanitizer: DomSanitizer);
    ngOnInit(): void;
    ngAfterViewInit(): void;
    ngOnDestroy(): void;
    writeValue(value: string): void;
    registerOnChange(fn: (_: any) => {}): void;
    registerOnTouched(fn: () => {}): void;
    validate(c: AbstractControl): ValidationErrors;
    insertContent(type: string, customContent?: string): void;
    togglePreview(): void;
    previewPanelClick(event: Event): void;
    fullScreen(): void;
    mdEditorResize(size: any): void;
    editorResize(timeOut?: number): void;
    onDragover(evt: DragEvent): void;
    onDrop(evt: DragEvent): void;
    onDragleave(evt: DragEvent): void;
    onAceEditorPaste(event: ClipboardEvent): void;
    private _updateMarkdownValue;
    private _updateDom;
    private _getRender;
    private _uploadFiles;
}
